import _extends from "@babel/runtime/helpers/esm/extends";
import { useState } from 'react';
import AtomInput, { inputTypes } from '@s-ui/react-atom-input';
import { useDropdown } from '../config.js';
import { getClassSearch } from './config.js';
import { jsx as _jsx } from "react/jsx-runtime";
export default function Search(props) {
  var _useState = useState(''),
    value = _useState[0],
    setValue = _useState[1];
  var _useDropdown = useDropdown(),
    setInputRef = _useDropdown.setInputRef,
    isOpen = _useDropdown.isOpen,
    focusFirstOption = _useDropdown.focusFirstOption,
    onSearch = _useDropdown.onSearch,
    searchPlaceholder = _useDropdown.searchPlaceholder,
    searchIcon = _useDropdown.searchIcon;
  var handleKeyDown = function handleKeyDown(ev) {
    setTimeout(function () {
      return focusFirstOption(ev);
    });
  };
  var onChange = function onChange(_ev, _ref) {
    var value = _ref.value;
    setValue(value);
    typeof onSearch === 'function' && setTimeout(function () {
      return onSearch({
        value: value
      });
    });
  };
  return /*#__PURE__*/_jsx("div", {
    className: getClassSearch(isOpen),
    onKeyDown: handleKeyDown,
    children: /*#__PURE__*/_jsx(AtomInput, _extends({
      type: inputTypes.TEXT,
      value: value,
      reference: setInputRef,
      onChange: onChange,
      placeholder: searchPlaceholder,
      leftIcon: searchIcon
    }, props))
  });
}
Search.displayName = 'Search';