import { useState } from 'react';
import AtomInput, { inputTypes } from '@s-ui/react-atom-input';
import MoleculeDropdownList from '@s-ui/react-molecule-dropdown-list';
import { useDropdown } from '../config.js';
import MoleculeInputSelect from './MoleculeInputSelect.js';
import Search from './Search.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var MoleculeSelectSingleSelection = function MoleculeSelectSingleSelection(props) {
  /* eslint-disable react/prop-types */
  var _props$value = props.value,
    value = _props$value === void 0 ? '' : _props$value,
    children = props.children,
    isOpen = props.isOpen,
    onToggle = props.onToggle,
    onChange = props.onChange,
    leftIcon = props.leftIcon,
    iconArrowDown = props.iconArrowDown,
    refMoleculeSelect = props.refMoleculeSelect,
    size = props.size,
    placeholder = props.placeholder,
    id = props.id,
    disabled = props.disabled,
    _props$optionsData = props.optionsData,
    optionsData = _props$optionsData === void 0 ? {} : _props$optionsData,
    required = props.required,
    selectSize = props.selectSize,
    tabIndex = props.tabIndex;
  var _useDropdown = useDropdown(),
    hasSearch = _useDropdown.hasSearch,
    isFirstOptionFocused = _useDropdown.isFirstOptionFocused,
    inputSearch = _useDropdown.inputSearch;
  var _useState = useState(false),
    focusedFirstOption = _useState[0],
    setFocusedFirstOption = _useState[1];
  var handleSelection = function handleSelection(ev, _ref) {
    var value = _ref.value;
    onChange(ev, {
      value: value
    });
    onToggle(ev, {
      isOpen: false
    });
    refMoleculeSelect && refMoleculeSelect.current && refMoleculeSelect.current.focus();
  };
  var handleKeyDown = function handleKeyDown(ev) {
    if (isFirstOptionFocused()) {
      setFocusedFirstOption(true);
    } else {
      setFocusedFirstOption(false);
    }
    if ((ev == null ? void 0 : ev.key) === 'Escape') {
      onToggle(ev, {
        isOpen: false
      });
    } else if ((ev == null ? void 0 : ev.key) === 'ArrowUp') {
      focusedFirstOption && setTimeout(function () {
        return inputSearch == null ? void 0 : inputSearch.focus();
      });
    }
  };
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx(MoleculeInputSelect, {
      disabled: disabled,
      id: id,
      isOpen: isOpen,
      value: optionsData[value] || '',
      onClick: function onClick(ev) {
        return onToggle(ev, {
          isOpen: !isOpen
        });
      },
      leftIcon: leftIcon,
      iconArrowDown: iconArrowDown,
      placeholder: placeholder,
      autoComplete: "off",
      required: required,
      size: selectSize,
      tabIndex: tabIndex,
      children: /*#__PURE__*/_jsx(AtomInput, {
        inputMode: inputTypes.NONE
      })
    }), hasSearch && /*#__PURE__*/_jsx(Search, {}), /*#__PURE__*/_jsx(MoleculeDropdownList, {
      size: size,
      visible: isOpen,
      onSelect: handleSelection,
      value: value,
      onKeyDown: handleKeyDown,
      children: children
    })]
  });
};
MoleculeSelectSingleSelection.displayName = 'MoleculeSelectSingleSelection';
MoleculeSelectSingleSelection.defaultProps = {
  value: ''
};
export default MoleculeSelectSingleSelection;