import { Children, createContext, useContext } from 'react';
import cx from 'classnames';
export var BASE_CLASS = "sui-MoleculeSelect";
export var CLASS_FOCUS = BASE_CLASS + "--focus";
export var CLASS_DISABLED = "is-disabled";
export var SELECT_STATES = {
  ERROR: 'error',
  SUCCESS: 'success',
  ALERT: 'alert'
};
export var DropdownContext = /*#__PURE__*/createContext();
export var useDropdown = function useDropdown() {
  return useContext(DropdownContext);
};
export var ENABLED_KEYS = ['Enter', 'ArrowDown', 'ArrowUp'];
export var SELECTION_KEYS = [' ', 'Enter'];
export var getOptionData = function getOptionData(children) {
  var optionsData = {};
  Children.forEach(children, function (child) {
    var _child$props = child.props,
      children = _child$props.children,
      value = _child$props.value;
    optionsData[value] = children;
  });
  return optionsData;
};
export var getClassName = function getClassName(_ref) {
  var _cx;
  var state = _ref.state,
    errorState = _ref.errorState,
    focus = _ref.focus,
    disabled = _ref.disabled;
  return cx(BASE_CLASS, errorState && BASE_CLASS + "--" + SELECT_STATES.ERROR, errorState === false && BASE_CLASS + "--" + SELECT_STATES.SUCCESS, state && BASE_CLASS + "--" + state, (_cx = {}, _cx[CLASS_FOCUS] = focus, _cx[CLASS_DISABLED] = disabled, _cx));
};